## blis 0.5.1

=== Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Top-level makefile for libflame linear algebra library.
#
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        libs libblis \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        flat-header flat-cblas-header \
        test \
        testblas blastest-f2c blastest-bin blastest-run \
        testsuite testsuite-bin \
        testsuite-run testsuite-run-fast testsuite-run-md testsuite-run-salt \
        testblis testblis-fast testblis-md testblis-salt \
        check checkblas \
        checkblis checkblis-fast checkblis-md checkblis-salt \
        install-headers install-libs install-lib-symlinks \
        showconfig \
        clean cleanmk cleanh cleanlib distclean \
        cleantest cleanblastest cleanblistest \
        changelog \
        install uninstall uninstall-old \
        uninstall-libs uninstall-lib-symlinks uninstall-headers \
        uninstall-old-libs uninstall-lib-symlinks uninstall-old-headers

#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - We don't need to define DIST_PATH, LIB_PATH, INC_PATH, or SHARE_PATH since
#   the defaults in common.mk (and config.mk) are designed to work with the
#   top-level Makefile.
#DIST_PATH  := .
#LIB_PATH    = ./lib/$(CONFIG_NAME)
#INC_PATH    = ./include/$(CONFIG_NAME)
#SHARE_PATH := .


#
# --- Include common makefile definitions --------------------------------------
#

# Define the name of the common makefile.
COMMON_MK_FILE    := common.mk

# Include the configuration file.
-include $(COMMON_MK_FILE)

# Detect whether we actually got the configuration file. If we didn't, then
# it is likely that the user has not yet generated it (via configure).
ifeq ($(strip $(COMMON_MK_INCLUDED)),yes)
COMMON_MK_PRESENT := yes
else
COMMON_MK_PRESENT := no
endif



#
# --- Main target variable definitions -----------------------------------------
#

# --- Object file paths ---

# Construct the base object file path for the current configuration.
BASE_OBJ_PATH          := ./$(OBJ_DIR)/$(CONFIG_NAME)

# Construct base object file paths corresponding to the four locations
# of source code.
BASE_OBJ_CONFIG_PATH   := $(BASE_OBJ_PATH)/$(CONFIG_DIR)
BASE_OBJ_FRAME_PATH    := $(BASE_OBJ_PATH)/$(FRAME_DIR)
BASE_OBJ_REFKERN_PATH  := $(BASE_OBJ_PATH)/$(REFKERN_DIR)
BASE_OBJ_KERNELS_PATH  := $(BASE_OBJ_PATH)/$(KERNELS_DIR)
BASE_OBJ_SANDBOX_PATH  := $(BASE_OBJ_PATH)/$(SANDBOX_DIR)

# --- Define install target names for static libraries ---

LIBBLIS_A_INST            := $(INSTALL_LIBDIR)/$(LIBBLIS_A)

# --- Define install target names for shared libraries ---

LIBBLIS_SO_INST           := $(INSTALL_LIBDIR)/$(LIBBLIS_SO)
LIBBLIS_SO_MAJ_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS_SONAME)

ifeq ($(IS_WIN),yes)
# The 'install' target does not create symlinks for Windows builds, so we don't
# bother defining LIBBLIS_SO_MMB_INST.
LIBBLIS_SO_MMB_INST       :=
else
LIBBLIS_SO_MMB_INST       := $(INSTALL_LIBDIR)/$(LIBBLIS).$(LIBBLIS_SO_MMB_EXT)
endif

# --- Determine which libraries to build ---

MK_LIBS                   :=
MK_LIBS_INST              :=
MK_LIBS_SYML              :=

ifeq ($(MK_ENABLE_STATIC),yes)
MK_LIBS                   += $(LIBBLIS_A_PATH)
MK_LIBS_INST              += $(LIBBLIS_A_INST)
MK_LIBS_SYML              +=
endif
ifeq ($(MK_ENABLE_SHARED),yes)
MK_LIBS                   += $(LIBBLIS_SO_PATH) \
                             $(LIBBLIS_SO_MAJ_PATH)
MK_LIBS_INST              += $(LIBBLIS_SO_MMB_INST)
MK_LIBS_SYML              += $(LIBBLIS_SO_INST) \
                             $(LIBBLIS_SO_MAJ_INST)
endif

# Strip leading, internal, and trailing whitespace.
MK_LIBS_INST              := $(strip $(MK_LIBS_INST))
MK_LIBS_SYML              := $(strip $(MK_LIBS_SYML))

# --- Define install directory for headers ---

# Set the path to the subdirectory of the include installation directory.
MK_INCL_DIR_INST          := $(INSTALL_INCDIR)/blis

# --- Define install directory for public makefile fragments ---

# Set the path to the subdirectory of the share installation directory.
MK_SHARE_DIR_INST         := $(INSTALL_SHAREDIR)/blis



#
# --- Library object definitions -----------------------------------------------
#

# In this section, we will isolate the relevant source code filepaths and
# convert them to lists of object filepaths. Relevant source code falls into
# four categories: configuration source; architecture-specific kernel source;
# reference kernel source; and general framework source.

# $(call gen-obj-paths-from-src file_exts, src_files, base_src_path, base_obj_path)
gen-obj-paths-from-src = $(foreach ch, $(1), \
                             $(patsubst $(3)/%.$(ch), \
                                        $(4)/%.o, \
                                        $(filter %.$(ch), $(2)) ) )

# Generate object file paths for source code found in the sub-configuration
# directories.
MK_CONFIG_OBJS      := $(call gen-obj-paths-from-src,$(CONFIG_SRC_SUFS),$(MK_CONFIG_SRC),$(CONFIG_PATH),$(BASE_OBJ_CONFIG_PATH))

# Generate object file paths for architecture-specific kernel source code.
# We target only .c, .s, and .S files. Note that MK_KERNELS_SRC is already
# limited to the kernel source corresponding to the kernel sets in
# KERNEL_LIST. This is because the configure script only propogated makefile
# fragments into those specific kernel subdirectories.
MK_KERNELS_OBJS     := $(call gen-obj-paths-from-src,$(KERNELS_SRC_SUFS),$(MK_KERNELS_SRC),$(KERNELS_PATH),$(BASE_OBJ_KERNELS_PATH))

# Generate object file paths for reference kernels, with one set of object
# files for each sub-configuration in CONFIG_LIST. Note that due to the
# nuances of naming the reference kernel files, we can't use the function
# gen-obj-paths-from-src as we do above and below.
MK_REFKERN_C        := $(filter %.c, $(MK_REFKERN_SRC))
MK_REFKERN_OBJS     := $(foreach arch, $(CONFIG_LIST), \
                           $(patsubst $(REFKERN_PATH)/%_$(REFNM).c, \
                                 $(BASE_OBJ_REFKERN_PATH)/$(arch)/%_$(arch)_$(REFNM).o, \
                                 $(MK_REFKERN_C) \
                            ) \
                        )

# Generate object file paths for all of the portable framework source code.
MK_FRAME_OBJS       := $(call gen-obj-paths-from-src,$(FRAME_SRC_SUFS),$(MK_FRAME_SRC),$(FRAME_PATH),$(BASE_OBJ_FRAME_PATH))

# Generate object file paths for the sandbox source code. If a sandbox was not
# enabled a configure-time, this variable will we empty.
MK_SANDBOX_OBJS     := $(call gen-obj-paths-from-src,$(SANDBOX_SRC_SUFS),$(MK_SANDBOX_SRC),$(SANDBOX_PATH),$(BASE_OBJ_SANDBOX_PATH))

# Combine all of the object files into some readily-accessible variables.
MK_BLIS_OBJS        := $(MK_CONFIG_OBJS) \
                       $(MK_KERNELS_OBJS) \
                       $(MK_REFKERN_OBJS) \
                       $(MK_FRAME_OBJS) \
                       $(MK_SANDBOX_OBJS)

# Optionally filter out the BLAS and CBLAS compatibility layer object files.
# This is not actually necessary, since each affected file is guarded by C
# preprocessor macros, but it but prevents "empty" object files from being
# added into the library (and reduces compilation time).
BASE_OBJ_BLAS_PATH  := $(BASE_OBJ_FRAME_PATH)/compat
BASE_OBJ_CBLAS_PATH := $(BASE_OBJ_FRAME_PATH)/compat/cblas
ifeq ($(MK_ENABLE_CBLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_CBLAS_PATH)/%.o, $(MK_BLIS_OBJS) )
endif
ifeq ($(MK_ENABLE_BLAS),no)
MK_BLIS_OBJS        := $(filter-out $(BASE_OBJ_BLAS_PATH)/%.o,  $(MK_BLIS_OBJS) )
endif



#
# --- Monolithic header definitions --------------------------------------------
#

# Define a list of headers to install. The default is to only install blis.h.
HEADERS_TO_INSTALL := $(BLIS_H_FLAT)

# If CBLAS is enabled, we also install cblas.h so the user does not need to
# change their source code to #include "blis.h" in order to access the CBLAS
# function prototypes and enums.
ifeq ($(MK_ENABLE_CBLAS),yes)
HEADERS_TO_INSTALL += $(CBLAS_H_FLAT)
endif



#
# --- public makefile fragment definitions -------------------------------------
#

# Define a list of makefile fragments to install.
FRAGS_TO_INSTALL := $(CONFIG_MK_FILE) \
                    $(COMMON_MK_FILE)



#
# --- BLAS test drivers definitions --------------------------------------------
#

# The location of the BLAS test suite's input files.
BLASTEST_INPUT_PATH    := $(DIST_PATH)/$(BLASTEST_DIR)/input

# The location of the BLAS test suite object directory.
BASE_OBJ_BLASTEST_PATH := $(BASE_OBJ_PATH)/$(BLASTEST_DIR)

# The locations of the BLAS test suite source code (f2c and drivers).
BLASTEST_F2C_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/f2c
BLASTEST_DRV_SRC_PATH  := $(DIST_PATH)/$(BLASTEST_DIR)/src

# The paths to object files we will create (f2c and drivers).
BLASTEST_F2C_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_F2C_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_F2C_SRC_PATH)/*.c)) \
                           )

BLASTEST_DRV_OBJS      := $(sort \
                          $(patsubst $(BLASTEST_DRV_SRC_PATH)/%.c, \
                                     $(BASE_OBJ_BLASTEST_PATH)/%.o, \
                                     $(wildcard $(BLASTEST_DRV_SRC_PATH)/*.c)) \
                           )

# libf2c name and location.
BLASTEST_F2C_LIB_NAME  := libf2c.a
BLASTEST_F2C_LIB       := $(BASE_OBJ_BLASTEST_PATH)/$(BLASTEST_F2C_LIB_NAME)

# The base names of each driver source file (ie: filename minus suffix).
BLASTEST_DRV_BASES     := $(basename $(notdir $(BLASTEST_DRV_OBJS)))

# The binary executable driver names.
BLASTEST_DRV_BINS      := $(addsuffix .x,$(BLASTEST_DRV_BASES))
BLASTEST_DRV_BIN_PATHS := $(addprefix $(BASE_OBJ_BLASTEST_PATH)/,$(BLASTEST_DRV_BINS))

# Binary executable driver "run-" names
BLASTEST_DRV_BINS_R    := $(addprefix run-,$(BLASTEST_DRV_BASES))

# Filter level-1, level-2, and level-3 names to different variables.
BLASTEST_DRV1_BASES    := $(filter %1,$(BLASTEST_DRV_BASES))
BLASTEST_DRV2_BASES    := $(filter %2,$(BLASTEST_DRV_BASES))
BLASTEST_DRV3_BASES    := $(filter %3,$(BLASTEST_DRV_BASES))

=== blastest/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for BLAS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all f2c bin \
        clean cleanf2c cleanobj cleanbin cleanout \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        run check



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_OBJ_PATH  := obj

F2C_LIB        := libf2c.a

F2C_PATH       := f2c
DRIVER_PATH    := src
BLIS_H_PATH    := $(BUILD_PATH)/$(BASE_INC_PATH)

INPUT_DIR      := input

# Gather all local object files.
F2C_OBJS       := $(sort $(patsubst $(F2C_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(F2C_PATH)/*.c)))

DRIVER_OBJS    := $(sort $(patsubst $(DRIVER_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(DRIVER_PATH)/*.c)))

# Extract base names for each test driver file.
DRIVER_BASES   := $(basename $(notdir $(DRIVER_OBJS)))

# Binary executable names.
DRIVER_BINS    := $(addsuffix .x,$(DRIVER_BASES))

# Binary run-rule names
DRIVER_BINS_R  := $(addprefix run-,$(DRIVER_BASES))

# Filter level-1, level-2, and level-3 names to different variables.
DRIVER1_BASES  := $(filter %1,$(DRIVER_BASES))
DRIVER2_BASES  := $(filter %2,$(DRIVER_BASES))
DRIVER3_BASES  := $(filter %3,$(DRIVER_BASES))

# The location of the script that checks the BLAS test output.
#BLASTEST_CHECK := $(DIST_PATH)/$(BUILD_DIR)/check-blastest.sh

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Suppress warnings about uninitialized functions, add local header
# paths and the path to blis.h to CFLAGS.
CFLAGS         += -Wno-maybe-uninitialized -Wno-parentheses -Wfatal-errors \
                  -I$(F2C_PATH) \
                  -I$(INC_PATH) -DHAVE_BLIS_H

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Override the location of the check-blastest.sh script.
#BLASTEST_CHECK := ./check-blastest.sh

TESTSUITE_WRAPPER       ?=

#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: check-env f2c bin

f2c: check-env $(F2C_LIB)

bin: check-env $(DRIVER_BINS)


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(F2C_PATH)/%.c
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif

$(TEST_OBJ_PATH)/%.o: $(DRIVER_PATH)/%.c
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- libf2c library archive rule --

$(F2C_LIB): $(F2C_OBJS)
ifeq ($(ENABLE_VERBOSE),yes)
	$(AR) $(ARFLAGS) $@ $?
	$(RANLIB) $@
else
	@echo "Archiving $@"
	@$(AR) $(ARFLAGS) $@ $?
	@$(RANLIB) $@
endif


# -- Executable file rules --

# first argument: the base name of the BLAS test driver.
define make-blat-rule
$(1).x: $(TEST_OBJ_PATH)/$(1).o $(F2C_LIB) $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $(TEST_OBJ_PATH)/$(1).o $(F2C_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $$@
else
	@echo "Linking $$@ against '$(F2C_LIB) $(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $(TEST_OBJ_PATH)/$(1).o $(F2C_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $$@
endif
endef

# Instantiate the rule above for each driver file.
$(foreach name, $(DRIVER_BASES), $(eval $(call make-blat-rule,$(name))))


# -- Test run rules --

run: $(DRIVER_BINS_R)

# A rule to run ?blat1.x driver files.
define make-run-blat1-rule
run-$(1): $(1).x
ifeq ($(ENABLE_VERBOSE),yes)
	$(TESTSUITE_WRAPPER) ./$(1).x > out.$(1)
else
	@echo "Running $(1).x > 'out.$(1)'"
	@$(TESTSUITE_WRAPPER) ./$(1).x > out.$(1)
endif
endef

# Instantiate the rule above for each level-1 driver file.
$(foreach name, $(DRIVER1_BASES), $(eval $(call make-run-blat1-rule,$(name))))

# A rule to run ?blat2.x and ?blat3.x driver files.
define make-run-blat23-rule
run-$(1): $(1).x
ifeq ($(ENABLE_VERBOSE),yes)
	$(TESTSUITE_WRAPPER) ./$(1).x < $(INPUT_DIR)/$(1).in
else
	@echo "Running $(1).x < '$(INPUT_DIR)/$(1).in' (output to 'out.$(1)')"
	@$(TESTSUITE_WRAPPER) ./$(1).x < $(INPUT_DIR)/$(1).in
endif
endef

# Instantiate the rule above for each level-2 driver file.
$(foreach name, $(DRIVER2_BASES), $(eval $(call make-run-blat23-rule,$(name))))

# Instantiate the rule above for each level-3 driver file.
$(foreach name, $(DRIVER3_BASES), $(eval $(call make-run-blat23-rule,$(name))))

check: run
ifeq ($(ENABLE_VERBOSE),yes)
	- $(BLASTEST_CHECK)
else
	@- $(BLASTEST_CHECK)
endif


# -- Clean rules --

cleanf2c:
	- $(RM_F) $(F2C_OBJS) $(F2C_LIB)

cleanobj:
	- $(RM_F) $(DRIVER_OBJS)

cleanbin:
	- $(RM_F) $(DRIVER_BINS)

cleanout:
	- $(RM_F) $(addprefix out.,$(DRIVER_BASES))

clean: cleanf2c cleanobj cleanbin cleanout

=== mpi_test/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis essl \
        clean cleanx



# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLAS library path(s). This is where the BLAS libraries reside.
BLAS_LIB_PATH  := $(HOME)/flame/lib
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64/
ESSL_LIB_PATH  := /soft/libraries/essl/current/lib64

# OpenBLAS
OPENBLAS_LIB   := $(BLAS_LIB_PATH)/libopenblas.a

# ATLAS
ATLAS_LIB      := $(BLAS_LIB_PATH)/libf77blas.a \
                  $(BLAS_LIB_PATH)/libatlas.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_sequential \
                  -lmkl_core \
                  -lmkl_intel_lp64

# ESSL
# Note: ESSL is named differently for SMP and/or BG
ESSL_LIB        := $(ESSL_LIB_PATH)/libesslsmpbg.a   \
                -L$(IBM_MAIN_DIR)/xlsmp/bg/3.1/bglib64/ \
				-L$(IBM_MAIN_DIR)/xlf/bg/14.1/bglib64/ \
				-lxlsmp -lxlf90_r -lxlfmath -lxl

# Accelerate
MAC_LIB        := -framework Accelerate



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(patsubst $(TEST_SRC_PATH)/%.c, \
                             $(TEST_OBJ_PATH)/%.o, \
                             $(wildcard $(TEST_SRC_PATH)/*.c))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)



#
# --- Targets/rules ------------------------------------------------------------
#

# Complete list of possible targets when defining 'all':
#
#   blis openblas atlas mkl mac essl
#
all: blis essl

blis: test_gemm_blis.x \
      test_hemm_blis.x \
      test_herk_blis.x \
      test_her2k_blis.x \
      test_trmm_blis.x \
      test_trsm_blis.x

essl: test_gemm_essl.x \
      test_hemm_essl.x \
      test_herk_essl.x \
      test_her2k_essl.x \
      test_trmm_essl.x \
      test_trsm_essl.x

openblas: test_gemv_openblas.x \
      test_ger_openblas.x \
      test_hemv_openblas.x \
      test_her_openblas.x \
      test_her2_openblas.x \
      test_trmv_openblas.x \
      test_trsv_openblas.x \
      \
      test_gemm_openblas.x \
      test_hemm_openblas.x \
      test_herk_openblas.x \
      test_her2k_openblas.x \
      test_trmm_openblas.x \
      test_trsm_openblas.x

atlas: test_gemv_atlas.x \
      test_ger_atlas.x \
      test_hemv_atlas.x \
      test_her_atlas.x \
      test_her2_atlas.x \
      test_trmv_atlas.x \
      test_trsv_atlas.x \
      \
      test_gemm_atlas.x \
      test_hemm_atlas.x \
      test_herk_atlas.x \
      test_her2k_atlas.x \
      test_trmm_atlas.x \
      test_trsm_atlas.x

mkl:  test_gemv_mkl.x \
      test_ger_mkl.x \
      test_hemv_mkl.x \
      test_her_mkl.x \
      test_her2_mkl.x \
      test_trmv_mkl.x \
      test_trsv_mkl.x \
      \
      test_gemm_mkl.x \
      test_hemm_mkl.x \
      test_herk_mkl.x \
      test_her2k_mkl.x \
      test_trmm_mkl.x \
      test_trsm_mkl.x

mac:  test_gemv_mac.x \
      test_ger_mac.x \
      test_hemv_mac.x \
      test_her_mac.x \
      test_her2_mac.x \
      test_trmv_mac.x \
      test_trsv_mac.x \
      \
      test_gemm_mac.x \
      test_hemm_mac.x \
      test_herk_mac.x \
      test_her2k_mac.x \
      test_trmm_mac.x \
      test_trsm_mac.x



# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

test_%_openblas.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"openblas\" -c $< -o $@

test_%_atlas.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"atlas\" -c $< -o $@

test_%_mkl.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"mkl\" -c $< -o $@

test_%_essl.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"essl\" -c $< -o $@

test_%_mac.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"mac\" -c $< -o $@

test_%_blis.o: test_%.c
	$(CC) $(CFLAGS) -DBLIS -c $< -o $@


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_openblas.x: test_%_openblas.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(OPENBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_atlas.x: test_%_atlas.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(ATLAS_LIB)    $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_mkl.x: test_%_mkl.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(MKL_LIB)      $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_essl.x: test_%_essl.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(ESSL_LIB)     $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_mac.x: test_%_mac.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(MAC_LIB)      $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_blis.x: test_%_blis.o $(LIBBLIS_LINK)
	$(LINKER) $<                             $(LIBBLIS_LINK) $(LDFLAGS) -o $@


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

=== test/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2017, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis openblas atlas mkl \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
BLAS_LIB_PATH  := $(HOME)/flame/lib
#MKL_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/mkl/lib/intel64
#MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
MKL_LIB_PATH   := ${MKLROOT}/lib/intel64
#ESSL_LIB_PATH  := $(HOME)/path/to/essl/changeme

# OpenBLAS
OPENBLAS_LIB   := $(BLAS_LIB_PATH)/libopenblas.a

# ATLAS
ATLAS_LIB      := $(BLAS_LIB_PATH)/libf77blas.a \
                  $(BLAS_LIB_PATH)/libatlas.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl

# ESSL
# Note: ESSL is named differently for SMP and/or BG
ESSL_TYPE      :=       # This is the 32b library on POWER
#ESSL_TYPE      := 6464  # This is the 64b library on POWER
#ESSL_TYPE      := bg    # This is the 32b single-threaded library on Blue Gene
#ESSL_TYPE      := smpbg # This is the 32b multi-threaded library on Blue Gene
ESSL_LIB       := $(ESSL_LIB_PATH)/libessl$(ESSL_TYPE).a

# Accelerate
MAC_LIB        := -framework Accelerate



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(patsubst $(TEST_SRC_PATH)/%.c, \
                             $(TEST_OBJ_PATH)/%.o, \
                             $(wildcard $(TEST_SRC_PATH)/*.c))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)



#
# --- Targets/rules ------------------------------------------------------------
#

# Complete list of possible targets when defining 'all':
#
#   blis openblas atlas mkl mac essl
#
#all: blis openblas atlas mkl
all: blis openblas mkl

blis: test_dotv_blis.x \
      test_axpyv_blis.x \
      test_gemv_blis.x \
      test_ger_blis.x \
      test_hemv_blis.x \
      test_her_blis.x \
      test_her2_blis.x \
      test_trmv_blis.x \
      test_trsv_blis.x \
      \
      test_gemm_blis.x \
      test_hemm_blis.x \
      test_herk_blis.x \
      test_her2k_blis.x \
      test_trmm_blis.x \
      test_trsm_blis.x

openblas: \
      test_dotv_openblas.x \
      test_axpyv_openblas.x \
      test_gemv_openblas.x \
      test_ger_openblas.x \
      test_hemv_openblas.x \
      test_her_openblas.x \
      test_her2_openblas.x \
      test_trmv_openblas.x \
      test_trsv_openblas.x \
      \
      test_gemm_openblas.x \
      test_hemm_openblas.x \
      test_herk_openblas.x \
      test_her2k_openblas.x \
      test_trmm_openblas.x \
      test_trsm_openblas.x

atlas: \
      test_dotv_atlas.x \
      test_axpyv_atlas.x \
      test_gemv_atlas.x \
      test_ger_atlas.x \
      test_hemv_atlas.x \
      test_her_atlas.x \
      test_her2_atlas.x \
      test_trmv_atlas.x \
      test_trsv_atlas.x \
      \
      test_gemm_atlas.x \
      test_hemm_atlas.x \
      test_herk_atlas.x \
      test_her2k_atlas.x \
      test_trmm_atlas.x \
      test_trsm_atlas.x

mkl:  test_dotv_mkl.x \
      test_axpyv_mkl.x \
      test_gemv_mkl.x \
      test_ger_mkl.x \
      test_hemv_mkl.x \
      test_her_mkl.x \
      test_her2_mkl.x \
      test_trmv_mkl.x \
      test_trsv_mkl.x \
      \
      test_gemm_mkl.x \
      test_hemm_mkl.x \
      test_herk_mkl.x \
      test_her2k_mkl.x \
      test_trmm_mkl.x \
      test_trsm_mkl.x

essl: test_dotv_essl.x \
      test_axpyv_essl.x \
      test_gemv_essl.x \
      test_ger_essl.x \
      test_hemv_essl.x \
      test_her_essl.x \
      test_her2_essl.x \
      test_trmv_essl.x \
      test_trsv_essl.x \
      \
      test_gemm_essl.x \
      test_hemm_essl.x \
      test_herk_essl.x \
      test_her2k_essl.x \
      test_trmm_essl.x \
      test_trsm_essl.x

mac:  test_dotv_mac.x \
      test_axpyv_mac.x \
      test_gemv_mac.x \
      test_ger_mac.x \
      test_hemv_mac.x \
      test_her_mac.x \
      test_her2_mac.x \
      test_trmv_mac.x \
      test_trsv_mac.x \
      \
      test_gemm_mac.x \
      test_hemm_mac.x \
      test_herk_mac.x \
      test_her2k_mac.x \
      test_trmm_mac.x \
      test_trsm_mac.x



# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

test_%_openblas.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"openblas\" -c $< -o $@

test_%_atlas.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"atlas\" -c $< -o $@

test_%_mkl.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"mkl\" -c $< -o $@

test_%_essl.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"essl\" -c $< -o $@

test_%_mac.o: test_%.c
	$(CC) $(CFLAGS) -DBLAS=\"mac\" -c $< -o $@

test_%_blis.o: test_%.c
	$(CC) $(CFLAGS) -DBLIS -c $< -o $@


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_openblas.x: test_%_openblas.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(OPENBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_atlas.x: test_%_atlas.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(ATLAS_LIB)    $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_mkl.x: test_%_mkl.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(MKL_LIB)      $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_essl.x: test_%_essl.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(ESSL_LIB)     $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_mac.x: test_%_mac.o $(LIBBLIS_LINK)
	$(LINKER) $<             $(MAC_LIB)      $(LIBBLIS_LINK) $(LDFLAGS) -o $@

test_%_blis.x: test_%_blis.o $(LIBBLIS_LINK)
	$(LINKER) $<                             $(LIBBLIS_LINK) $(LDFLAGS) -o $@


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

=== testsuite/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for BLIS testsuite.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all bin clean \
        check-env check-env-mk check-env-fragments check-env-make-defs \
        run run-amd64 run-x86 run-arm



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ..
LIB_PATH    = ../lib/$(CONFIG_NAME)
INC_PATH    = ../include/$(CONFIG_NAME)
SHARE_PATH := ..
endif


#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := src
TEST_OBJ_PATH  := obj

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Binary executable name.
TESTSUITE_BIN  := test_libblis.x



#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: check-env bin

bin: check-env $(TESTSUITE_BIN)


# --- Environment check rules ---

check-env: check-env-make-defs check-env-fragments check-env-config-mk

check-env-config-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
    $(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-env-make-defs: check-env-fragments
ifeq ($(MAKE_DEFS_MK_PRESENT),no)
    $(error Cannot proceed: make_defs.mk not detected! Invalid configuration)
endif


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- Executable file rules --

$(TESTSUITE_BIN): $(TEST_OBJS) $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $(TEST_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $@
else
	@echo "Linking $@ against '$(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $(TEST_OBJS) $(LIBBLIS_LINK) $(LDFLAGS) -o $@
endif


# -- Test run/check rules --

run: $(TESTSUITE_BIN)
ifeq ($(ENABLE_VERBOSE),yes)
	./$(TESTSUITE_BIN) > $(TESTSUITE_OUT_FILE)

else
	@echo "Running $(TESTSUITE_BIN) with output redirected to '$(TESTSUITE_OUT_FILE)'"
	@./$(TESTSUITE_BIN) > $(TESTSUITE_OUT_FILE)
endif

check: run
ifeq ($(ENABLE_VERBOSE),yes)
	- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
else
	@- $(TESTSUITE_CHECK) $(TESTSUITE_OUT_FILE)
endif


# -- Clean rules --

clean:
	- $(RM_F) $(TEST_OBJS) $(TESTSUITE_BIN)

=== windows/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#



#
# --- Include variables determined at configure-time --------------------------
#
CONFIGURE_DEFS = config\config.mk

!if exist ( $(CONFIGURE_DEFS) )
!include $(CONFIGURE_DEFS)
!else
!error nmake: $(CONFIGURE_DEFS) does not exist! Run configure.cmd first.
!endif



#
# --- Include environment- and build-specific definitions ----------------------
#

MAKE_DEFS = build\defs.mk

# Include build definitions
!if exist ( $(MAKE_DEFS) )
!include $(MAKE_DEFS)
!else
!error nmake: $(MAKE_DEFS) does not exist! Your libblis distribution may be incomplete.
!endif



#
# --- Variable modifications ---------------------------------------------------
#



#
# --- High-level rules ---------------------------------------------------------
#

all: libblis

libblis: libblis-lib

libblis-objs: $(BLIS_OBJS)

libblis-lib: $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS_LIB)

libblis-dll: $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS_DLL)

lib: libblis-lib

dll: libblis-dll

install: install-lib install-headers

install-lib: $(INSTALL_PREFIX_LIB)\$(LIBBLIS).lib

install-dll: $(INSTALL_PREFIX_DLL)\$(LIBBLIS).dll \
             $(INSTALL_PREFIX_DLL)\$(LIBBLIS).lib \
             $(INSTALL_PREFIX_DLL)\$(LIBBLIS).exp

install-headers: $(INSTALL_PREFIX_INC)\$(BLIS_H)

clean: clean-build clean-log

distclean: clean-config clean-build clean-log



#
# --- Source code (inference) rules --------------------------------------------
#

# --- C source files in flamec directory ---
{$(SRC_BLI_DIRPATH)}.c{$(OBJ_BLI_DIRPATH)}.obj:
!ifdef VERBOSE
	if not exist $(OBJ_BLI_DIRPATH) \
	   ( $(MKDIR) $(OBJ_BLI_DIRPATH) )
	$(CC) $(CFLAGS) /c $< /Fo$@
!else
	@if not exist $(OBJ_BLI_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(OBJ_BLI_DIRPATH) directory ) & \
	    ( $(MKDIR) $(OBJ_BLI_DIRPATH) ) )
	@$(ECHO) nmake: Compiling $<
	@$(CC) $(CFLAGS) /c $< /Fo$@ >> $(CC_LOG_FILE)
!endif



#
# --- Library generation rules -------------------------------------------------
#

# --- Static library ---
$(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS_LIB): libblis-objs
!ifdef VERBOSE
	if not exist $(LIB_LIBBLIS_DIRPATH) \
	   ( $(MKDIR) $(LIB_LIBBLIS_DIRPATH) )
	$(COPY) $(OBJ_BLI_DIRPATH)\*.obj $(LIB_LIBBLIS_DIRPATH)
	$(CD) $(LIB_LIBBLIS_DIRPATH)
	$(LIB) $(LIB_OPTIONS) $(LIB_BLI_OUTPUT_ARG) $(LIB_BLI_INPUT_ARGS)
	$(DEL) *.obj
	$(CD) $(TOP_BUILD_DIR_ABS)
!else
	@if not exist $(LIB_LIBBLIS_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(LIB_LIBBLIS_DIRPATH) directory ) & \
	    ( $(MKDIR) $(LIB_LIBBLIS_DIRPATH) ) )
	@$(ECHO) nmake: Creating static library $@
	@$(COPY) $(OBJ_BLI_DIRPATH)\*.obj $(LIB_LIBBLIS_DIRPATH) >> $(COPY_LOG_FILE)
	@$(CD) $(LIB_LIBBLIS_DIRPATH)
	@$(LIB) /VERBOSE $(LIB_OPTIONS) $(LIB_BLI_OUTPUT_ARG) $(LIB_BLI_INPUT_ARGS)
	@$(DEL) *.obj
	@$(CD) $(TOP_BUILD_DIR_ABS)
!endif

# --- Dynamic library (object code file, import library, and export file) ---
$(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS_DLL): libblis-objs
!ifdef VERBOSE
	if not exist $(DLL_LIBBLIS_DIRPATH) \
	   ( $(MKDIR) $(DLL_LIBBLIS_DIRPATH) )
	$(COPY) $(OBJ_BLI_DIRPATH)\*.obj $(DLL_LIBBLIS_DIRPATH) >> $(COPY_LOG_FILE)
	$(CD) $(DLL_LIBBLIS_DIRPATH)
	$(DIR) /B *.obj > $(OBJ_LIST_FILE)
	$(GENDLL) $(LIBBLIS) $(LIBBLIS) $(CC) $(LINKARGS_FILEPATH) $(SYM_DEF_FILEPATH) /objlist $(OBJ_LIST_FILE)
	$(DEL) $(OBJ_LIST_FILE)
	$(DEL) *.obj
	$(CD) $(TOP_BUILD_DIR_ABS)
!else
	@if not exist $(DLL_LIBBLIS_DIRPATH) \
	 (  ( $(ECHO) nmake: Creating $(DLL_LIBBLIS_DIRPATH) directory ) & \
	    ( $(MKDIR) $(DLL_LIBBLIS_DIRPATH) ) )
	@$(ECHO) nmake: Creating dynamic library $@
	@$(COPY) $(OBJ_BLI_DIRPATH)\*.obj $(DLL_LIBBLIS_DIRPATH) >> $(COPY_LOG_FILE)
	@$(CD) $(DLL_LIBBLIS_DIRPATH)
	@$(DIR) /B *.obj > $(OBJ_LIST_FILE)
	@$(GENDLL) $(LIBBLIS) $(LIBBLIS) $(CC) $(LINKARGS_FILEPATH) $(SYM_DEF_FILEPATH) /objlist $(OBJ_LIST_FILE)
	@$(DEL) $(OBJ_LIST_FILE)
	@$(DEL) *.obj
	@$(CD) $(TOP_BUILD_DIR_ABS)
!endif



#
# --- Install rules ------------------------------------------------------------
#

# --- Header files ---
$(INSTALL_PREFIX_INC)\$(BLIS_H): $(INC_BLI_DIRPATH)\$(BLIS_H) \
                                  $(BUILD_DIRNAME)\$(BLI_CONFIG_H)
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_INC) \
	   ( $(MKDIR) $(INSTALL_PREFIX_INC) )
    $(COPY) $(BUILD_DIRNAME)\$(BLI_CONFIG_H) $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
    $(COPY) $(INC_BLI_DIRPATH)\*.h $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
!else
	@if not exist $(INSTALL_PREFIX_INC) \
	    ( $(MKDIR) $(INSTALL_PREFIX_INC) )
    @$(ECHO) nmake: Installing libblis header files to $(INSTALL_PREFIX_INC)
    @$(COPY) $(BUILD_DIRNAME)\$(BLI_CONFIG_H) $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
    @$(COPY) $(INC_BLI_DIRPATH)\*.h $(INSTALL_PREFIX_INC) >> $(COPY_LOG_FILE)
!endif

# --- Static library ---
$(INSTALL_PREFIX_LIB)\$(LIBBLIS).lib: $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_LIB) ( $(MKDIR) $(INSTALL_PREFIX_LIB) )
	if     exist $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib \
	   ( $(COPY) $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib $(INSTALL_PREFIX_LIB) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_LIB) ( $(MKDIR) $(INSTALL_PREFIX_LIB) )
	@if     exist $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib \
	 (  ( $(ECHO) nmake: Installing $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib to $(INSTALL_PREFIX_LIB) ) & \
	    ( $(COPY) $(LIB_LIBBLIS_DIRPATH)\$(LIBBLIS).lib $(INSTALL_PREFIX_LIB) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (object code) ---
$(INSTALL_PREFIX_DLL)\$(LIBBLIS).dll: $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll \
	   ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).dll $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (import library) ---
$(INSTALL_PREFIX_DLL)\$(LIBBLIS).lib: $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib \
	   ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).lib $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif

# --- Dynamic library (export file) ---
$(INSTALL_PREFIX_DLL)\$(LIBBLIS).exp: $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp
!ifdef VERBOSE
	if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp \
	   ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) )
!else
	@if not exist $(INSTALL_PREFIX_DLL) ( $(MKDIR) $(INSTALL_PREFIX_DLL) )
	@if     exist $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp \
	 (  ( $(ECHO) nmake: Installing $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp to $(INSTALL_PREFIX_DLL) ) & \
	    ( $(COPY) $(DLL_LIBBLIS_DIRPATH)\$(LIBBLIS).exp $(INSTALL_PREFIX_DLL) >> $(COPY_LOG_FILE) ) )
!endif



#
# --- Clean rules --------------------------------------------------------------
#

clean-log:
!ifdef VERBOSE
	if exist $(CC_LOG_FILE) \
	   ( $(DEL) $(CC_LOG_FILE) )
	if exist $(FC_LOG_FILE) \
	   ( $(DEL) $(FC_LOG_FILE) )
	if exist $(COPY_LOG_FILE) \
	   ( $(DEL) $(COPY_LOG_FILE) )
!else
	@if exist $(CC_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(CC_LOG_FILE) ) & \
	    ( $(DEL) $(CC_LOG_FILE) ) )
	@if exist $(FC_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(FC_LOG_FILE) ) & \
	    ( $(DEL) $(FC_LOG_FILE) ) )
	@if exist $(COPY_LOG_FILE) \
	 (  ( $(ECHO) nmake: Deleting $(COPY_LOG_FILE) ) & \
	    ( $(DEL) $(COPY_LOG_FILE) ) )
!endif

clean-config:
!ifdef VERBOSE
	if exist $(CNF_DIRNAME) \
	   ( $(RMDIR) $(CNF_DIRNAME) )
	if exist $(INC_DIRNAME) \
	   ( $(RMDIR) $(INC_DIRNAME) )
	if exist $(SRC_DIRNAME) \
	   ( $(RMDIR) $(SRC_DIRNAME) )
!else
	@if exist $(CNF_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(CNF_DIRNAME) directory ) & \
	    ( $(RMDIR) $(CNF_DIRNAME) ) )
	@if exist $(INC_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(INC_DIRNAME) directory ) & \
	    ( $(RMDIR) $(INC_DIRNAME) ) )
	@if exist $(SRC_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(SRC_DIRNAME) directory ) & \
	    ( $(RMDIR) $(SRC_DIRNAME) ) )
!endif

clean-build:
!ifdef VERBOSE
	if exist $(OBJ_DIRNAME) \
	   ( $(RMDIR) $(OBJ_DIRNAME) )
	if exist $(LIB_DIRNAME) \
	   ( $(RMDIR) $(LIB_DIRNAME) )
	if exist $(DLL_DIRNAME) \
	   ( $(RMDIR) $(DLL_DIRNAME) )
!else
	@if exist $(OBJ_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(OBJ_DIRNAME) directory ) & \
	    ( $(RMDIR) $(OBJ_DIRNAME) ) )
	@if exist $(LIB_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(LIB_DIRNAME) directory ) & \
	    ( $(RMDIR) $(LIB_DIRNAME) ) )
	@if exist $(DLL_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(DLL_DIRNAME) directory ) & \
	    ( $(RMDIR) $(DLL_DIRNAME) ) )
!endif

# Useful for developing when all we want to do is remove the library products.
clean-lib:
!ifdef VERBOSE
	if exist $(LIB_DIRNAME) \
	   ( $(RMDIR) $(LIB_DIRNAME) )
	if exist $(DLL_DIRNAME) \
	   ( $(RMDIR) $(DLL_DIRNAME) )
!else
	@if exist $(LIB_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(LIB_DIRNAME) directory ) & \
	    ( $(RMDIR) $(LIB_DIRNAME) ) )
	@if exist $(DLL_DIRNAME) \
	 (  ( $(ECHO) nmake: Deleting $(DLL_DIRNAME) directory ) & \
	    ( $(RMDIR) $(DLL_DIRNAME) ) )
!endif



#
# --- Help target --------------------------------------------------------------
#

help:
	@$(NMAKE_HELP)

=== examples/oapi/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for BLIS object API example code.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all bin clean run



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif

#ifneq ($(strip $(BLIS_LIB_PATH)),)
#LIB_PATH   := $(BLIS_LIB_PATH)
#endif
#
#ifneq ($(strip $(BLIS_INC_PATH)),)
#INC_PATH   := $(BLIS_INC_PATH)
#endif
#
#ifneq ($(strip $(BLIS_SHARE_PATH)),)
#SHARE_PATH := $(BLIS_SHARE_PATH)
#endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Binary executable name.
TEST_BINS      := 00obj_basic.x \
                  01obj_attach.x \
                  02obj_ij.x \
                  03obj_view.x \
                  04level0.x \
                  05level1v.x \
                  06level1m.x \
                  07level1m_diag.x \
                  08level2.x \
                  09level3.x \
                  10util.x \
                  11gemm_md.x



#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: bin

bin: $(TEST_BINS)


# --- Environment check rules ---

check-env: check-env-make-defs check-env-fragments check-env-config-mk

check-env-config-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
    $(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-env-make-defs: check-env-fragments
ifeq ($(MAKE_DEFS_MK_PRESENT),no)
    $(error Cannot proceed: make_defs.mk not detected! Invalid configuration)
endif


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- Executable file rules --

%.x: %.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $< $(LIBBLIS_LINK) $(LDFLAGS) -o $@
else
	@echo "Linking $@ against '$(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $< $(LIBBLIS_LINK) $(LDFLAGS) -o $@
endif

# -- Test run rules --

#run: $(TEST_BIN)
#	./$(TEST_BIN)

# -- Clean rules --

clean:
	- $(RM_F) $(TEST_OBJS) $(TEST_BINS)

=== examples/tapi/Makefile ===
#
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for BLIS typed API example code.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all bin clean run



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)

# Binary executable name.
TEST_BINS      := 00level1v.x \
                  01level1m.x \
                  02level1m_diag.x \
				  03level2.x \
				  04level3.x \
				  05util.x



#
# --- Targets/rules ------------------------------------------------------------
#

# --- Primary targets ---

all: bin

bin: $(TEST_BINS)


# --- Environment check rules ---

check-env: check-env-make-defs check-env-fragments check-env-config-mk

check-env-config-mk:
ifeq ($(CONFIG_MK_PRESENT),no)
    $(error Cannot proceed: config.mk not detected! Run configure first)
endif

check-env-make-defs: check-env-fragments
ifeq ($(MAKE_DEFS_MK_PRESENT),no)
    $(error Cannot proceed: make_defs.mk not detected! Invalid configuration)
endif


# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) -c $< -o $@
else
	@echo "Compiling $@"
	@$(CC) $(CFLAGS) -c $< -o $@
endif


# -- Executable file rules --

%.x: %.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER) $< $(LIBBLIS_LINK) $(LDFLAGS) -o $@
else
	@echo "Linking $@ against '$(LIBBLIS_LINK) $(LDFLAGS)'"
	@$(LINKER) $< $(LIBBLIS_LINK) $(LDFLAGS) -o $@
endif

# -- Test run rules --

#run: $(TEST_BIN)
#	./$(TEST_BIN)

# -- Clean rules --

clean:
	- $(RM_F) $(TEST_OBJS) $(TEST_BINS)

=== test/3m4m/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#  Copyright (C) 2018, Advanced Micro Devices, Inc.
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis-gemm-st openblas-gemm-st mkl-gemm-st acml-gemm-st \
        blis-gemm-mt openblas-gemm-mt mkl-gemm-mt acml-gemm-mt \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib
#MKL_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/mkl/lib/intel64
MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64
#MKL_LIB_PATH   := ${MKLROOT}/lib/intel64
#ICC_LIB_PATH   := /opt/apps/intel/13/composer_xe_2013.2.146/compiler/lib/intel64
ACML_LIB_PATH  := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_int64/lib
ACMLP_LIB_PATH := $(HOME_LIB_PATH)/acml/5.3.1/gfortran64_fma4_mp_int64/lib

# OpenBLAS
OPENBLAS_LIB   := $(HOME_LIB_PATH)/libopenblas.a
OPENBLASP_LIB  := $(HOME_LIB_PATH)/libopenblasp.a

# ATLAS
ATLAS_LIB      := $(HOME_LIB_PATH)/libf77blas.a \
                  $(HOME_LIB_PATH)/libatlas.a

# MKL
MKL_LIB        := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_sequential \
                  -lpthread -lm -ldl
#MKLP_LIB       := -L$(MKL_LIB_PATH) \
#                  -lmkl_intel_thread \
#                  -lmkl_core \
#                  -lmkl_intel_ilp64 \
#                  -L$(ICC_LIB_PATH) \
#                  -liomp5
MKLP_LIB       := -L$(MKL_LIB_PATH) \
                  -lmkl_intel_lp64 \
                  -lmkl_core \
                  -lmkl_gnu_thread \
                  -lpthread -lm -ldl -fopenmp
                  #-L$(ICC_LIB_PATH) \
                  #-lgomp

# ACML
ACML_LIB       := -L$(ACML_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml
ACMLP_LIB      := -L$(ACMLP_LIB_PATH) \
                  -lgfortran -lm -lrt -ldl -lacml_mp



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Datatype
DT_S     := -DDT=BLIS_FLOAT
DT_D     := -DDT=BLIS_DOUBLE
DT_C     := -DDT=BLIS_SCOMPLEX
DT_Z     := -DDT=BLIS_DCOMPLEX

# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Complex implementation type
D3MHW    := -DIND=BLIS_3MH
D3M1     := -DIND=BLIS_3M1
D4MHW    := -DIND=BLIS_4MH
D4M1B    := -DIND=BLIS_4M1B
D4M1A    := -DIND=BLIS_4M1A
D1M      := -DIND=BLIS_1M
DNAT     := -DIND=BLIS_NAT

# Implementation string
STR_3MHW := -DSTR=\"3mhw\"
STR_3M1  := -DSTR=\"3m1\"
STR_4MHW := -DSTR=\"4mhw\"
STR_4M1B := -DSTR=\"4m1b\"
STR_4M1A := -DSTR=\"4m1a\"
STR_1M   := -DSTR=\"1m\"
STR_NAT  := -DSTR=\"asm\"
STR_OBL  := -DSTR=\"openblas\"
STR_MKL  := -DSTR=\"mkl\"
STR_ACML := -DSTR=\"acml\"

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=56 \
            -DP_END=2800 \
            -DP_INC=56

PDEF_MT  := -DP_BEGIN=160 \
            -DP_END=8000 \
            -DP_INC=160



#
# --- Targets/rules ------------------------------------------------------------
#

all:        all-st all-mt
blis:       blis-st blis-mt
openblas:   openblas-st openblas-mt
mkl:        mkl-st mkl-mt

all-st:     blis-st openblas-st mkl-st
all-mt:     blis-mt openblas-mt mkl-mt

blis-st:    blis-nat-st
blis-mt:    blis-nat-mt

blis-ind:   blis-ind-st blis-ind-mt
blis-nat:   blis-nat-st blis-nat-mt

blis-ind-st: \
      test_cgemm_3mhw_blis_st.x \
      test_zgemm_3mhw_blis_st.x \
      test_cgemm_3m1_blis_st.x \
      test_zgemm_3m1_blis_st.x \
      test_cgemm_4mhw_blis_st.x \
      test_zgemm_4mhw_blis_st.x \
      test_cgemm_4m1b_blis_st.x \
      test_zgemm_4m1b_blis_st.x \
      test_cgemm_4m1a_blis_st.x \
      test_zgemm_4m1a_blis_st.x \
      test_cgemm_1m_blis_st.x \
      test_zgemm_1m_blis_st.x

blis-ind-mt: \
      test_cgemm_3mhw_blis_mt.x \
      test_zgemm_3mhw_blis_mt.x \
      test_cgemm_3m1_blis_mt.x \
      test_zgemm_3m1_blis_mt.x \
      test_cgemm_4mhw_blis_mt.x \
      test_zgemm_4mhw_blis_mt.x \
      test_cgemm_4m1b_blis_mt.x \
      test_zgemm_4m1b_blis_mt.x \
      test_cgemm_4m1a_blis_mt.x \
      test_zgemm_4m1a_blis_mt.x \
      test_cgemm_1m_blis_mt.x \
      test_zgemm_1m_blis_mt.x

blis-nat-st: \
      test_sgemm_asm_blis_st.x \
      test_dgemm_asm_blis_st.x \
      test_cgemm_asm_blis_st.x \
      test_zgemm_asm_blis_st.x \
      test_shemm_asm_blis_st.x \
      test_dhemm_asm_blis_st.x \
      test_chemm_asm_blis_st.x \
      test_zhemm_asm_blis_st.x \
      test_sherk_asm_blis_st.x \
      test_dherk_asm_blis_st.x \
      test_cherk_asm_blis_st.x \
      test_zherk_asm_blis_st.x \
      test_strmm_asm_blis_st.x \
      test_dtrmm_asm_blis_st.x \
      test_ctrmm_asm_blis_st.x \
      test_ztrmm_asm_blis_st.x \
      test_strsm_asm_blis_st.x \
      test_dtrsm_asm_blis_st.x \
      test_ctrsm_asm_blis_st.x \
      test_ztrsm_asm_blis_st.x

blis-nat-mt: \
      test_sgemm_asm_blis_mt.x \
      test_dgemm_asm_blis_mt.x \
      test_cgemm_asm_blis_mt.x \
      test_zgemm_asm_blis_mt.x \
      test_shemm_asm_blis_mt.x \
      test_dhemm_asm_blis_mt.x \
      test_chemm_asm_blis_mt.x \
      test_zhemm_asm_blis_mt.x \
      test_sherk_asm_blis_mt.x \
      test_dherk_asm_blis_mt.x \
      test_cherk_asm_blis_mt.x \
      test_zherk_asm_blis_mt.x \
      test_strmm_asm_blis_mt.x \
      test_dtrmm_asm_blis_mt.x \
      test_ctrmm_asm_blis_mt.x \
      test_ztrmm_asm_blis_mt.x \
      test_strsm_asm_blis_mt.x \
      test_dtrsm_asm_blis_mt.x \
      test_ctrsm_asm_blis_mt.x \
      test_ztrsm_asm_blis_mt.x

openblas-st: \
      test_sgemm_openblas_st.x \
      test_dgemm_openblas_st.x \
      test_cgemm_openblas_st.x \
      test_zgemm_openblas_st.x \
      test_shemm_openblas_st.x \
      test_dhemm_openblas_st.x \
      test_chemm_openblas_st.x \
      test_zhemm_openblas_st.x \
      test_sherk_openblas_st.x \
      test_dherk_openblas_st.x \
      test_cherk_openblas_st.x \
      test_zherk_openblas_st.x \
      test_strmm_openblas_st.x \
      test_dtrmm_openblas_st.x \
      test_ctrmm_openblas_st.x \
      test_ztrmm_openblas_st.x \
      test_strsm_openblas_st.x \
      test_dtrsm_openblas_st.x \
      test_ctrsm_openblas_st.x \
      test_ztrsm_openblas_st.x

openblas-mt: \
      test_sgemm_openblas_mt.x \
      test_dgemm_openblas_mt.x \
      test_cgemm_openblas_mt.x \
      test_zgemm_openblas_mt.x \
      test_shemm_openblas_mt.x \
      test_dhemm_openblas_mt.x \
      test_chemm_openblas_mt.x \
      test_zhemm_openblas_mt.x \
      test_sherk_openblas_mt.x \
      test_dherk_openblas_mt.x \
      test_cherk_openblas_mt.x \
      test_zherk_openblas_mt.x \
      test_strmm_openblas_mt.x \
      test_dtrmm_openblas_mt.x \
      test_ctrmm_openblas_mt.x \
      test_ztrmm_openblas_mt.x \
      test_strsm_openblas_mt.x \
      test_dtrsm_openblas_mt.x \
      test_ctrsm_openblas_mt.x \
      test_ztrsm_openblas_mt.x

mkl-st: \
      test_sgemm_mkl_st.x \
      test_dgemm_mkl_st.x \
      test_cgemm_mkl_st.x \
      test_zgemm_mkl_st.x \
      test_shemm_mkl_st.x \
      test_dhemm_mkl_st.x \
      test_chemm_mkl_st.x \
      test_zhemm_mkl_st.x \
      test_sherk_mkl_st.x \
      test_dherk_mkl_st.x \
      test_cherk_mkl_st.x \
      test_zherk_mkl_st.x \
      test_strmm_mkl_st.x \
      test_dtrmm_mkl_st.x \
      test_ctrmm_mkl_st.x \
      test_ztrmm_mkl_st.x \
      test_strsm_mkl_st.x \
      test_dtrsm_mkl_st.x \
      test_ctrsm_mkl_st.x \
      test_ztrsm_mkl_st.x

mkl-mt: \
      test_sgemm_mkl_mt.x \
      test_dgemm_mkl_mt.x \
      test_cgemm_mkl_mt.x \
      test_zgemm_mkl_mt.x \
      test_shemm_mkl_mt.x \
      test_dhemm_mkl_mt.x \
      test_chemm_mkl_mt.x \
      test_zhemm_mkl_mt.x \
      test_sherk_mkl_mt.x \
      test_dherk_mkl_mt.x \
      test_cherk_mkl_mt.x \
      test_zherk_mkl_mt.x \
      test_strmm_mkl_mt.x \
      test_dtrmm_mkl_mt.x \
      test_ctrmm_mkl_mt.x \
      test_ztrmm_mkl_mt.x \
      test_strsm_mkl_mt.x \
      test_dtrsm_mkl_mt.x \
      test_ctrsm_mkl_mt.x \
      test_ztrsm_mkl_mt.x




# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

# blis 3mhw
test_z%_3mhw_blis_st.o: test_%.c Makefile
	$(CC) $(CFLAGS) $(PDEF_ST) $(DT_Z) $(BLI_DEF) $(D3MHW) $(STR_3MHW) $(STR_ST) -c $< -o $@

test_c%_3mhw_blis_st.o: test_%.c Makefile

=== test/exec_sizes/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        blis openblas atlas mkl \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
BLAS_LIB_PATH  := $(HOME)/flame/lib
#MKL_LIB_PATH   := $(HOME)/intel/mkl/lib/intel64/
MKL_LIB_PATH   := ${MKLROOT}/lib/intel64

# OpenBLAS, ATLAS, and MKL libraries.
#BLAS_LIB       := $(LIB_PATH)/libblas.a
#BLAS_LIB       := $(LIB_PATH)/libgoto.a
#BLAS_LIB       := $(LIB_PATH)/libgoto2.a
OBLAS_LIB       := $(BLAS_LIB_PATH)/libopenblas.a
ABLAS_LIB       := $(BLAS_LIB_PATH)/libf77blas.a \
                   $(BLAS_LIB_PATH)/libatlas.a
#MBLAS_LIB       := -L$(MKL_LIB_PATH) \
#                   -lmkl_sequential \
#                   -lmkl_core \
#                   -lmkl_intel_lp64
#MBLAS_LIB      := -Wl,--start-group \
#                  $(MKL_LIB_PATH)/libmkl_sequential.a \
#                  $(MKL_LIB_PATH)/libmkl_core.a \
#                  $(MKL_LIB_PATH)/libmkl_intel_ilp64.a \
#                  -Wl,--end-group \
#                  -lpthread -lm
MBLAS_LIB       := -L$(MKL_LIB_PATH) \
                   -lmkl_intel_lp64 \
                   -lmkl_core \
                   -lmkl_sequential \
                   -lpthread -lm -ldl



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

## Gather all local source files.
TEST_SIZES_SRC := test_size.c

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)



#
# --- Targets/rules ------------------------------------------------------------
#

MAKE_BLIS      := yes
MAKE_OPENBLAS  := yes
MAKE_MKL       := yes
MAKE_ATLAS     := no
MAKE_DCOMPLEX  := yes

ifeq ($(MAKE_BLIS),yes)
TEST_BINS += test_blis01 \
             test_blis02 \
             test_blis03 \
             test_blis04 \
             test_blis05 \
             test_blis06
ifeq ($(MAKE_DCOMPLEX),yes)
TEST_BINS += test_blis07 \
             test_blis08 \
             test_blis09 \
             test_blis10 \
             test_blis11 \
             test_blis12
endif
endif
ifeq ($(MAKE_OPENBLAS),yes)
TEST_BINS += test_oblas01 \
             test_oblas02 \
             test_oblas03 \
             test_oblas04 \
             test_oblas05 \
             test_oblas06
ifeq ($(MAKE_DCOMPLEX),yes)
TEST_BINS += test_oblas07 \
             test_oblas08 \
             test_oblas09 \
             test_oblas10 \
             test_oblas11 \
             test_oblas12
endif
endif
ifeq ($(MAKE_ATLAS),yes)
TEST_BINS += test_ablas01 \
             test_ablas02 \
             test_ablas03 \
             test_ablas04 \
             test_ablas05 \
             test_ablas06
ifeq ($(MAKE_DCOMPLEX),yes)
TEST_BINS += test_ablas07 \
             test_ablas08 \
             test_ablas09 \
             test_ablas10 \
             test_ablas11 \
             test_ablas12
endif
endif
ifeq ($(MAKE_MKL),yes)
TEST_BINS += test_mblas01 \
             test_mblas02 \
             test_mblas03 \
             test_mblas04 \
             test_mblas05 \
             test_mblas06
ifeq ($(MAKE_DCOMPLEX),yes)
TEST_BINS += test_mblas07 \
             test_mblas08 \
             test_mblas09 \
             test_mblas10 \
             test_mblas11 \
             test_mblas12
endif
endif


# --Object file rules --

all: $(TEST_BINS)

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@


# -- Executable file rules --

# BLIS rules
test_blis01:
	$(CC) $(CFLAGS) -DNBLIS=1  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis02:
	$(CC) $(CFLAGS) -DNBLIS=2  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis03:
	$(CC) $(CFLAGS) -DNBLIS=3  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis04:
	$(CC) $(CFLAGS) -DNBLIS=4  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis05:
	$(CC) $(CFLAGS) -DNBLIS=5  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis06:
	$(CC) $(CFLAGS) -DNBLIS=6  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis07:
	$(CC) $(CFLAGS) -DNBLIS=7  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis08:
	$(CC) $(CFLAGS) -DNBLIS=8  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis09:
	$(CC) $(CFLAGS) -DNBLIS=9  $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis10:
	$(CC) $(CFLAGS) -DNBLIS=10 $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis11:
	$(CC) $(CFLAGS) -DNBLIS=11 $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_blis12:
	$(CC) $(CFLAGS) -DNBLIS=12 $(TEST_SIZES_SRC)              $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x

# OpenBLAS rules
test_oblas01:
	$(CC) $(CFLAGS) -DNBLAS=1  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas02:
	$(CC) $(CFLAGS) -DNBLAS=2  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas03:
	$(CC) $(CFLAGS) -DNBLAS=3  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas04:
	$(CC) $(CFLAGS) -DNBLAS=4  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas05:
	$(CC) $(CFLAGS) -DNBLAS=5  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas06:
	$(CC) $(CFLAGS) -DNBLAS=6  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas07:
	$(CC) $(CFLAGS) -DNBLAS=7  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas08:
	$(CC) $(CFLAGS) -DNBLAS=8  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas09:
	$(CC) $(CFLAGS) -DNBLAS=9  $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas10:
	$(CC) $(CFLAGS) -DNBLAS=10 $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas11:
	$(CC) $(CFLAGS) -DNBLAS=11 $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_oblas12:
	$(CC) $(CFLAGS) -DNBLAS=12 $(TEST_SIZES_SRC) $(OBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x

# ATLAS BLAS rules
test_ablas01:
	$(CC) $(CFLAGS) -DNBLAS=1  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas02:
	$(CC) $(CFLAGS) -DNBLAS=2  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas03:
	$(CC) $(CFLAGS) -DNBLAS=3  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas04:
	$(CC) $(CFLAGS) -DNBLAS=4  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas05:
	$(CC) $(CFLAGS) -DNBLAS=5  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas06:
	$(CC) $(CFLAGS) -DNBLAS=6  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas07:
	$(CC) $(CFLAGS) -DNBLAS=7  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas08:
	$(CC) $(CFLAGS) -DNBLAS=8  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas09:
	$(CC) $(CFLAGS) -DNBLAS=9  $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas10:
	$(CC) $(CFLAGS) -DNBLAS=10 $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas11:
	$(CC) $(CFLAGS) -DNBLAS=11 $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_ablas12:
	$(CC) $(CFLAGS) -DNBLAS=12 $(TEST_SIZES_SRC) $(ABLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x

# MKL BLAS rules
test_mblas01:
	$(CC) $(CFLAGS) -DNBLAS=1  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas02:
	$(CC) $(CFLAGS) -DNBLAS=2  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas03:
	$(CC) $(CFLAGS) -DNBLAS=3  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas04:
	$(CC) $(CFLAGS) -DNBLAS=4  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas05:
	$(CC) $(CFLAGS) -DNBLAS=5  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas06:
	$(CC) $(CFLAGS) -DNBLAS=6  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas07:
	$(CC) $(CFLAGS) -DNBLAS=7  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas08:
	$(CC) $(CFLAGS) -DNBLAS=8  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas09:
	$(CC) $(CFLAGS) -DNBLAS=9  $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas10:
	$(CC) $(CFLAGS) -DNBLAS=10 $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas11:
	$(CC) $(CFLAGS) -DNBLAS=11 $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x
test_mblas12:
	$(CC) $(CFLAGS) -DNBLAS=12 $(TEST_SIZES_SRC) $(MBLAS_LIB) $(LIBBLIS_LINK) $(LDFLAGS) -o $@.x


# -- Clean rules --

=== test/mixeddt/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
#
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all all-st all-mt \
        blis blis-st blis-mt \
        blis-nat blis-nat-st blis-nat-mt \
        openblas openblas-st openblas-mt \
        mkl mkl-st mkl-mt \
        blis-gemm-st blis-gemm-mt \
        blis-gemm-nat-st blis-gemm-nat-mt \
        openblas-gemm-st openblas-gemm-mt \
        mkl-gemm-st mkl-gemm-mt \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- BLAS and LAPACK implementations ------------------------------------------
#

# BLIS library and header path. This is simply wherever it was installed.
#BLIS_LIB_PATH  := $(INSTALL_PREFIX)/lib
#BLIS_INC_PATH  := $(INSTALL_PREFIX)/include/blis

# BLIS library.
#BLIS_LIB       := $(BLIS_LIB_PATH)/libblis.a

# BLAS library path(s). This is where the BLAS libraries reside.
HOME_LIB_PATH  := $(HOME)/flame/lib



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-frame-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the "framework" CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add local header paths to CFLAGS.
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Which library?
BLI_DEF  := -DBLIS
BLA_DEF  := -DBLAS

# Single or multithreaded string
STR_ST   := -DTHR_STR=\"st\"
STR_MT   := -DTHR_STR=\"mt\"

# Problem size specification
PDEF_ST  := -DP_BEGIN=40 \
            -DP_END=2000 \
            -DP_INC=40

PDEF_MT  := -DP_BEGIN=160 \
            -DP_END=8000 \
            -DP_INC=160

# Enumerate possible datatypes and computation precisions.
dts := s d c z
prs := s d

# Various functions that help us construct the datatype combinations and then
# extract the needed datatype strings and C preprocessor define flags.
get-char-c = $(word 1,$(subst _, ,$(1)))
get-char-a = $(word 2,$(subst _, ,$(1)))
get-char-b = $(word 3,$(subst _, ,$(1)))
get-char-x = $(word 4,$(subst _, ,$(1)))
get-cstr   = $(call get-char-c,$(1))$(call get-char-a,$(1))$(call get-char-b,$(1))$(call get-char-x,$(1))

get-cdef-a = $(strip $(subst s,-DDTA=BLIS_FLOAT, \
                     $(subst d,-DDTA=BLIS_DOUBLE, \
                     $(subst c,-DDTA=BLIS_SCOMPLEX, \
                     $(subst z,-DDTA=BLIS_DCOMPLEX,$(call get-char-a,$(1)))))))
get-cdef-b = $(strip $(subst s,-DDTB=BLIS_FLOAT, \
                     $(subst d,-DDTB=BLIS_DOUBLE, \
                     $(subst c,-DDTB=BLIS_SCOMPLEX, \
                     $(subst z,-DDTB=BLIS_DCOMPLEX,$(call get-char-b,$(1)))))))
get-cdef-c = $(strip $(subst s,-DDTC=BLIS_FLOAT, \
                     $(subst d,-DDTC=BLIS_DOUBLE, \
                     $(subst c,-DDTC=BLIS_SCOMPLEX, \
                     $(subst z,-DDTC=BLIS_DCOMPLEX,$(call get-char-c,$(1)))))))
get-cdef-x = $(strip $(subst s,-DDTX=BLIS_FLOAT, \
                     $(subst d,-DDTX=BLIS_DOUBLE,$(call get-char-x,$(1)))))
get-cdefs  = $(call get-cdef-c,$(1)) $(call get-cdef-a,$(1)) $(call get-cdef-b,$(1)) $(call get-cdef-x,$(1))

# Define a function to return the appropriate -DSTR= and -D[BLIS|BLAS] flags.
get-idefs = $(strip $(subst intern,-DSTR=\"$(1)\" -DBLIS, \
                    $(subst ad_hoc,-DSTR=\"$(1)\" -DBLAS, \
                    $(subst    mkl,-DSTR=\"$(1)\" -DBLAS,$(1)))))

# Enumerate all possible datatype combinations.
DT_CODES := $(foreach dt0,$(dts),$(foreach dt1,$(dts),$(foreach dt2,$(dts),$(foreach pr,$(prs),$(dt0)_$(dt1)_$(dt2)_$(pr)))))

# Build a list of the datatype strings.
DT_COMBOS := $(foreach code,$(DT_CODES),$(call get-cstr,$(code)))

# Build a list of BLIS, OpenBLAS, and MKL executables.
INTERN_OBJS_ST := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_intern_st.o)
INTERN_BINS_ST := $(patsubst %.o,%.x,$(INTERN_OBJS_ST))
AD_HOC_OBJS_ST := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_ad_hoc_st.o)
AD_HOC_BINS_ST := $(patsubst %.o,%.x,$(AD_HOC_OBJS_ST))

INTERN_OBJS_MT := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_intern_mt.o)
INTERN_BINS_MT := $(patsubst %.o,%.x,$(INTERN_OBJS_MT))
AD_HOC_OBJS_MT := $(foreach combo,$(DT_COMBOS),test_$(combo)gemm_ad_hoc_mt.o)
AD_HOC_BINS_MT := $(patsubst %.o,%.x,$(AD_HOC_OBJS_MT))



#
# --- Targets/rules ------------------------------------------------------------
#

all:       st

st:        intern-st ad_hoc-st
mt:        intern-mt ad_hoc-mt

intern-st: $(INTERN_BINS_ST)
ad_hoc-st: $(AD_HOC_BINS_ST)
intern-mt: $(INTERN_BINS_MT)
ad_hoc-mt: $(AD_HOC_BINS_MT)

#blis:        test_ssssgemm_asm_blis_st.x \
#             test_sssdgemm_asm_blis_st.x \
#             test_ssdsgemm_asm_blis_st.x \
#             test_sdssgemm_asm_blis_st.x \
#             test_dsssgemm_asm_blis_st.x \
#             test_dddsgemm_asm_blis_st.x \
#             test_ddddgemm_asm_blis_st.x


# --Object file rules --

# Define the function that will be used to instantiate compilation rules
# for the various implementations.
define make-st-rule
test_$(call get-cstr,$(1))gemm_$(2)_st.o: test_gemm.c Makefile
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) $(PDEF_ST) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_ST) -c $$< -o $$@
else
	@echo "Compiling $$@"
	@$(CC) $(CFLAGS) $(PDEF_ST) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_ST) -c $$< -o $$@
endif
endef

define make-mt-rule
test_$(call get-cstr,$(1))gemm_$(2)_mt.o: test_gemm.c Makefile
ifeq ($(ENABLE_VERBOSE),yes)
	$(CC) $(CFLAGS) $(PDEF_MT) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_MT) -c $$< -o $$@
else
	@echo "Compiling $$@"
	@$(CC) $(CFLAGS) $(PDEF_MT) $(call get-cdefs,$(1)) $(call get-idefs,$(2)) $(STR_MT) -c $$< -o $$@
endif
endef


# Define the implementations for which we will instantiate compilation rules.
IMPLS := intern ad_hoc

# Instantiate the rule function make-st-rule() and make-mt-rule for each
# implementation in IMPLS and each of the datatype "codes" in DT_CODES.
$(foreach impl,$(IMPLS), \
$(foreach code,$(DT_CODES),$(eval $(call make-st-rule,$(code),$(impl)))))

$(foreach impl,$(IMPLS), \
$(foreach code,$(DT_CODES),$(eval $(call make-mt-rule,$(code),$(impl)))))


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_%_ad_hoc_st.x: test_%_ad_hoc_st.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif

test_%_ad_hoc_mt.x: test_%_ad_hoc_mt.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif


test_%_intern_st.x: test_%_intern_st.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif

test_%_intern_mt.x: test_%_intern_mt.o $(LIBBLIS_LINK)
ifeq ($(ENABLE_VERBOSE),yes)
	$(LINKER)  $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	$(RM_F) $<
else
	@@echo "Linking $@ to '$(LIBBLIS_LINK)'"
	@$(LINKER) $<  $(LIBBLIS_LINK) $(LDFLAGS) -o $@
	@$(RM_F) $<
endif


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

cleanout:
	- $(RM_F) *.m

=== test/thread_ranges/Makefile ===
#!/bin/bash
#
#  BLIS    
#  An object-based framework for developing high-performance BLAS-like
#  libraries.
#
#  Copyright (C) 2014, The University of Texas at Austin
#
#  Redistribution and use in source and binary forms, with or without
#  modification, are permitted provided that the following conditions are
#  met:
#   - Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#   - Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
#   - Neither the name(s) of the copyright holder(s) nor the names of its
#     contributors may be used to endorse or promote products derived
#     from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
#

#
# Makefile
#
# Field G. Van Zee
# 
# Makefile for standalone BLIS test drivers.
#

#
# --- Makefile PHONY target definitions ----------------------------------------
#

.PHONY: all \
        test-ranges \
        clean cleanx



#
# --- Determine makefile fragment location -------------------------------------
#

# Comments:
# - DIST_PATH is assumed to not exist if BLIS_INSTALL_PATH is given.
# - We must use recursively expanded assignment for LIB_PATH and INC_PATH in
#   the second case because CONFIG_NAME is not yet set.
ifneq ($(strip $(BLIS_INSTALL_PATH)),)
LIB_PATH   := $(BLIS_INSTALL_PATH)/lib
INC_PATH   := $(BLIS_INSTALL_PATH)/include/blis
SHARE_PATH := $(BLIS_INSTALL_PATH)/share/blis
else
DIST_PATH  := ../..
LIB_PATH    = ../../lib/$(CONFIG_NAME)
INC_PATH    = ../../include/$(CONFIG_NAME)
SHARE_PATH := ../..
endif



#
# --- Include common makefile definitions --------------------------------------
#

# Include the common makefile fragment.
-include $(SHARE_PATH)/common.mk



#
# --- General build definitions ------------------------------------------------
#

TEST_SRC_PATH  := .
TEST_OBJ_PATH  := .

# Gather all local object files.
TEST_OBJS      := $(sort $(patsubst $(TEST_SRC_PATH)/%.c, \
                                    $(TEST_OBJ_PATH)/%.o, \
                                    $(wildcard $(TEST_SRC_PATH)/*.c)))

# Override the value of CINCFLAGS so that the value of CFLAGS returned by
# get-user-cflags-for() is not cluttered up with include paths needed only
# while building BLIS.
CINCFLAGS      := -I$(INC_PATH)

# Use the CFLAGS for the configuration family.
CFLAGS         := $(call get-user-cflags-for,$(CONFIG_NAME))

# Add installed and local header paths to CFLAGS
CFLAGS         += -I$(TEST_SRC_PATH)

# Locate the libblis library to which we will link.
LIBBLIS_LINK   := $(LIB_PATH)/$(LIBBLIS_L)


# Datatype
DT_S     := -DDT=BLIS_FLOAT
DT_D     := -DDT=BLIS_DOUBLE
DT_C     := -DDT=BLIS_SCOMPLEX
DT_Z     := -DDT=BLIS_DCOMPLEX

# Problem size specification
PDEF_MT  := -DP_BEGIN=400 \
            -DP_END=8000 \
            -DP_INC=400



#
# --- Targets/rules ------------------------------------------------------------
#

all: test-ranges

test-ranges: \
      test_ranges.x



# --Object file rules --

$(TEST_OBJ_PATH)/%.o: $(TEST_SRC_PATH)/%.c
	$(CC) $(CFLAGS) -c $< -o $@

# blis asm
test_%.o: test_%.c
	$(CC) $(CFLAGS) $(PDEF_MT) $(DT_D) -c $< -o $@


# -- Executable file rules --

# NOTE: For the BLAS test drivers, we place the BLAS libraries before BLIS
# on the link command line in case BLIS was configured with the BLAS
# compatibility layer. This prevents BLIS from inadvertently getting called
# for the BLAS routines we are trying to test with.

test_ranges.x: test_ranges.o $(LIBBLIS_LINK)
	$(LINKER) $< $(LIBBLIS_LINK) $(LDFLAGS) -o $@


# -- Clean rules --

clean: cleanx

cleanx:
	- $(RM_F) *.o *.x

=== debian/changelog ===
blis (0.5.1-11) unstable; urgency=medium

  * Add version script for libblas.so.3 to export only {C,}BLAS ABI.
  * Add test-name feature to Autopkgtest control file.
    And remove unnecessary test cases.
  * Update lintian overrides.
  * Add upstream/metadata file.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 06 Feb 2019 08:43:40 +0000

blis (0.5.1-10) unstable; urgency=medium

  * Correct BLIS64 alternative name: libblis64.so.@SOVER@-@DEB_HOST_MULTIARCH@

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 05 Feb 2019 03:36:17 +0000

blis (0.5.1-9) unstable; urgency=medium

  * Add Restrictions: needs-root to maintainer-script autopkgtest cases.
  * Rename libblis{,64-}2-symbols.* to libblis{,64-}2-XXX.symbols.*
  * Rewrite the shell loop for creating symlinks for symbols files.
  * Guard test targets with nocheck detector in rules.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 05 Feb 2019 02:35:23 +0000

blis (0.5.1-8) unstable; urgency=medium

  * Make all BLIS variants co-installable. (Closes: #919272)
    + Move all shlibs and headers to private directories.
    + Rewrite libblis2-openmp.{postinst,prerm} into common templates.
    + Rewrite libblis64-2-openmp.{postinst,prerm} into common templates.
    + Rewrite libblis-openmp-dev.{postinst,prerm} into common templates.
    + Rewrite libblis64-openmp-dev.{postinst,prerm} into common templates.
    + Add libblis{,64}.a as slave links for libblis.so.
    + Generate maintainer scripts from templates.
    - Remove all Conflicts relationship between BLIS variants.
  * Virtual Package / Provides updates:
    - libblas{,64}.so   is no longer provided by libblis{,64}-dev.
    - libblas{,64}.so.3 is no longer provided by libblis{,64-}2.
    + libblis-{...}-dev   Provides libblis.so,     libblas.so
    + libblis2-{...}      Provides libblis.so.2,   libblas.so.3
    + libblis64-{...}-dev Provides libblis64.so,   libblas64.so
    + libblis64-2-{...}   Provides libblis64.so.2, libblas64.so.3
  * Autopkgtest Updates:
    + Add test cases for maintainer scripts.
    + Run libblas-test against all BLIS variants.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 04 Feb 2019 06:14:56 +0000

blis (0.5.1-7) unstable; urgency=medium

  * Modify upstream header to amend kFreeBSD detection.
  * Patch upstream Makefile to build separate libblas.so* .
  * Install separate libblas into blis{,64} subdirs, (Closes: #919273)
    where its SONAME is "libblas.so.3".
  * Change libblas.so* provider from libblis.so* to blis*/libblas.so*.
  * Override dh_dwz to append --no-dwz-multifile option.
  * Don't track symbols list for private shared objects.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 27 Jan 2019 06:18:53 +0000

blis (0.5.1-6) unstable; urgency=medium

  * Cherry-pick upstream commit to fix configure on kfreebsd.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 22 Jan 2019 14:35:38 +0000

blis (0.5.1-5) unstable; urgency=medium

  * Use generic kernel for armel,armhf architectures. (Closes: #919710)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 19 Jan 2019 02:39:44 +0000

blis (0.5.1-4) unstable; urgency=medium

  * Fix the problematic patch for Hurd.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Jan 2019 05:02:27 +0000

blis (0.5.1-3) unstable; urgency=medium

  * Run fast version of test on all architectures.
  * Add patch to port BLIS to GNU Hurd OS.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Jan 2019 04:43:00 +0000

blis (0.5.1-2) unstable; urgency=medium

  * Bump debhelper compat to 12.
  * Bump Standards-Version to 4.3.0 (no change).
  * Let libblis-dev (instead of libblis-*-dev) provide libblas.so.
  * Change (arm32,arm64) targets into (cortexa15,cortexa57).
  * Refresh symbols control file for arm64 and armhf.
  * Autopkgtest Depends on build-essential instead of merely gcc.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 16 Jan 2019 12:20:46 +0000

blis (0.5.1-1) unstable; urgency=medium

  * New upstream version 0.5.1
  * Add version condition to dependencies of libblis-1 and libblis64-1.
  * Collect symbol patches for various architectures from buildd.
  * Bump SOVERSION from 1 to 2, and SONAME to libblis.so.2
  * Overhaul d/rules for the SOVERSION bump and auto symlink creation.
    - Remove all symlinks under debian directory.
  * Remove all patches, problems fixed upstream.
  * Export a proper PYTHON variable for upstream build system.
  * Update dependency-template in symbols control file, stripping the
    threadding identifier postfix.
  * Override symbols-declares-dependency-on-other-package on shlib packages.
    The dependency template should really be libblis2 (meta) or
    libblis64-2 (meta) instead of a specific backend used during build.
  * Add autopkgtest control file with 6 test cases.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 03 Jan 2019 11:36:29 +0000

blis (0.5.0-1) unstable; urgency=low

  * Initial upload based on Nico Schlömer's work. (Closes: #909457)

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 18 Dec 2018 03:13:26 +0000

=== debian/control ===
Source: blis
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>,
           Mo Zhou <cdluminate@gmail.com>,
Section: math
Priority: optional
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/blis
Vcs-Git: https://salsa.debian.org/science-team/blis.git
Homepage: https://github.com/flame/blis
Build-Depends: debhelper (>= 12~), python3,

Package: libblis-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2 (= ${binary:Version}), ${misc:Depends},
 libblis-openmp-dev | libblis-pthread-dev | libblis-serial-dev,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls development files.

Package: libblis-openmp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains openmp version of development files.

Package: libblis-pthread-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains pthread version of development files.

Package: libblis-serial-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libblis2-serial (= ${binary:Version}), ${misc:Depends}
Provides: libblis.so, libblas.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains serial version development files.

Package: libblis2
Architecture: any
Multi-Arch: same
Section: metapackages
Depends: ${misc:Depends}, ${shlibs:Depends},
  libblis2-openmp (= ${binary:Version})
  | libblis2-pthread (= ${binary:Version})
  | libblis2-serial (= ${binary:Version}),
Description: BLAS-like Library Instantiation Software Framework - shared library
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls the shared library.

Package: libblis2-openmp
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework - shared library
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the openmp version of shared library.

Package: libblis2-pthread
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework - shared library
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the pthread version of shared library.

Package: libblis2-serial
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Provides: libblis.so.2, libblas.so.3,
Description: BLAS-like Library Instantiation Software Framework - shared library
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the serial version of shared library.

Package: libblis64-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2 (= ${binary:Version}), ${misc:Depends},
 libblis64-openmp-dev | libblis64-pthread-dev | libblis64-serial-dev,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package pulls the development files with 64bit interface.

Package: libblis64-openmp-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-openmp (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the openmp version of development files.

Package: libblis64-pthread-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-pthread (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to
 isolate essential kernels of computation that, when optimized, immediately
 enable optimized implementations of most of its commonly used and
 computationally intensive operations. BLIS is written in ISO C99 and available
 under a new/modified/3-clause BSD license. While BLIS exports a new BLAS-like
 API, it also includes a BLAS compatibility layer which gives application
 developers access to BLIS implementations via traditional BLAS routine calls.
 An object-based API is also available for more experienced users.
 .
 The package contains the pthread version of development files.

Package: libblis64-serial-dev
Architecture: amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64
Multi-Arch: same
Section: libdevel
Depends: libblis64-2-serial (= ${binary:Version}), ${misc:Depends}
Provides: libblis64.so, libblas64.so,
Description: BLAS-like Library Instantiation Software Framework
 BLIS is a portable software framework for instantiating high-performance
 BLAS-like dense linear algebra libraries. The framework was designed to

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYTHON=/usr/bin/python3  # for the upstream build system

# Select target architecture
CONFIG_amd64      = x86_64
CONFIG_armhf      = generic
CONFIG_arm64      = cortexa57
CONFIG_ppc64el    = generic
CONFIG            = $(word 1, $(CONFIG_$(DEB_HOST_ARCH)) generic)

# SOVERSION
SOVER := 2

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 kfreebsd-amd64 arm64 mips64el ppc64el s390x ppc64 riscv64 sparc64))
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial 64-$(SOVER)-openmp 64-$(SOVER)-pthread 64-$(SOVER)-serial
else
FLAVORS := $(SOVER)-openmp $(SOVER)-pthread $(SOVER)-serial
endif

FLAGS := \
	--enable-verbose-make \
	--prefix=/usr \
	--enable-cblas \
	--enable-static \
	--enable-shared \
	--libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

SRCS := $(filter-out debian $(FLAVORS), $(wildcard ./*))


%:
	dh $@ -Smakefile

create_symlinks:
	# BLIS/BLAS
	# armhf: upstream's armv7a kernel assumes NEON. Using generic kernels currently.
	# ln -sr libblis$(SOVER)-symbols.armhf libblis$(SOVER)-$$j.symbols.$$i
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis$(SOVER)-XXX.symbols.generic libblis$(SOVER)-$$j.symbols ;\
		for i in amd64 arm64; do  \
			ln -sr libblis$(SOVER)-XXX.symbols.$$i libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
		for i in i386 x32; do \
			ln -sr libblis$(SOVER)-XXX.symbols.i386 libblis$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;
	# BLIS64/BLAS64
	set -e; cd debian; for j in openmp pthread serial; do \
		ln -sr libblis64-$(SOVER)-symbols.generic libblis64-$(SOVER)-$$j.symbols ;\
		for i in amd64 arm64; do \
			ln -sr libblis64-$(SOVER)-symbols.$$i libblis64-$(SOVER)-$$j.symbols.$$i ;\
		done;\
	done;

config_%:
	# Generate maintainer scripts from templates
	set -e; cd debian; if test -z "$$(echo $* | grep 64)"; then \
		cp libblis2-XXX.postinst     libblis$*.postinst; \
		cp libblis2-XXX.prerm        libblis$*.prerm; \
		cp libblis-XXX-dev.postinst  libblis$(subst $(SOVER),,$*)-dev.postinst; \
		cp libblis-XXX-dev.prerm     libblis$(subst $(SOVER),,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst $(SOVER),,$*)-dev.postinst \
			libblis$(subst $(SOVER),,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst $(SOVER),,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/38/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/37/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/36/g" $$SCRIPT; \
			fi; \
		done; \
	else \
		cp libblis64-2-XXX.postinst     libblis$*.postinst; \
		cp libblis64-2-XXX.prerm        libblis$*.prerm; \
		cp libblis64-XXX-dev.postinst   libblis$(subst $(SOVER)-,,$*)-dev.postinst; \
		cp libblis64-XXX-dev.prerm      libblis$(subst $(SOVER)-,,$*)-dev.prerm; \
		for SCRIPT in libblis$*.postinst libblis$*.prerm \
			libblis$(subst $(SOVER)-,,$*)-dev.postinst \
			libblis$(subst $(SOVER)-,,$*)-dev.prerm; do \
			sed -i -e "s/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g" \
				-e "s/@SUBDIR@/blis$(subst $(SOVER)-,,$*)/g" \
				-e "s/@SOVER@/$(SOVER)/g" \
				$$SCRIPT; \
			if test -n "$$(echo $* | grep openmp)"; then \
				sed -i -e "s/@BLIS_PRI@/38/g" $$SCRIPT; \
			elif test -n "$$(echo $* | grep pthread)"; then \
				sed -i -e "s/@BLIS_PRI@/37/g" $$SCRIPT; \
			else \
				sed -i -e "s/@BLIS_PRI@/36/g" $$SCRIPT; \
			fi; \
		done; \
	fi;
	# Run upstream configure script in duplicated source root directories
	mkdir $*
	cp -r $(SRCS) $*/
	set -e; cd $*; if test -z "$$(echo $* | grep 64)"; then \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -t $(subst $(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	else \
		if test -z "$$(echo $* | grep serial)"; then \
			./configure $(FLAGS) -b 64 -i 64 -t $(subst 64-$(SOVER)-,,$*) $(CONFIG); \
		else \
			./configure $(FLAGS) -b 64 -i 64 --disable-threading $(CONFIG); \
		fi; \
		echo "$*/usr/lib/*/libblis64.so.* usr/lib/$(DEB_HOST_MULTIARCH)/" > \
			debian/libblis$*.install; \
	fi;

override_dh_auto_configure: $(addprefix config_, $(FLAVORS)) create_symlinks
	:

build_%:
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas64.so.3 LIBBLIS=libblis64 ; \
	else \
		dh_auto_build -B$* -- DEB_LIBBLAS=libblas.so.3; \
	fi;

override_dh_auto_build: $(addprefix build_, $(FLAVORS))
	:

test_%:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; if test -n "$$(echo $* | grep 64)"; then \
		$(MAKE) -C$* check LIBBLIS=libblis64; \
	else \
		$(MAKE) -C$* check; \
	fi;
endif

override_dh_auto_test: $(addprefix test_, $(FLAVORS))
	:

install_%:
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*
	# In case we forgot to compile something
	-set -e; if test -n "$$(echo $* | grep 64)"; then \
		dh_auto_install -B$* -- LIBBLIS=libblis64; \
	else \
		dh_auto_install -B$*; \
	fi;
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*

	# Install things manually
	set -e; if test -z "$$(echo $* | grep 64)"; then \
		install -Dm0644 $*/lib/*/libblis.so     debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so.$(SOVER) ;\
		install -Dm0644 $*/lib/*/libblas.so.3   debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so.3 ;\
		ln -s libblas.so.3                      debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblas.so ;\
		install -Dm0644 $*/lib/*/libblis.a      debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.a ;\
		ln -s libblis.so.$(SOVER)               debian/libblis$(subst $(SOVER),,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/libblis.so ;\
		install -Dm0644 $*/include/*/blis.h     debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/blis.h ;\
		install -Dm0644 $*/include/*/cblas.h    debian/libblis$(subst $(SOVER),,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER),,$*)/cblas-blis.h ;\
	else \
		install -Dm0644 $*/lib/*/libblis64.so   debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.so.$(SOVER) ;\
		install -Dm0644 $*/lib/*/libblas64.so.3 debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblas64.so.3 ;\
		ln -s libblas64.so.3                    debian/libblis$*/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblas64.so ;\
		install -Dm0644 $*/lib/*/libblis64.a    debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.a ;\
		ln -s libblis64.so.$(SOVER)             debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/lib/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/libblis64.so ;\
		install -Dm0644 $*/include/*/blis.h     debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/blis64.h ;\
		install -Dm0644 $*/include/*/cblas.h    debian/libblis$(subst $(SOVER)-,,$*)-dev/usr/include/$(DEB_HOST_MULTIARCH)/blis$(subst $(SOVER)-,,$*)/cblas64-blis.h ;\
	fi;

override_dh_auto_install: $(addprefix install_, $(FLAVORS))
	# Don't use the debian/tmp directory
	-$(RM) -rf debian/tmp/*

override_dh_makeshlibs:
	dh_makeshlibs -Xlibblas

override_dh_dwz:
	dh_dwz --no-dwz-multifile

=== debian/tests/control ===
# ---------------------- functionality tests ----------------------------------

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-openmp sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-openmp-dev,
Features: test-name=blis_blas_test_openmp

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-pthread sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-pthread-dev,
Features: test-name=blis_blas_test_pthread

Test-Command: LD_LIBRARY_PATH=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH)/blis-serial sh /usr/share/doc/libblas-test/examples/run_blas_tests.sh
Restrictions: allow-stderr
Depends: libblas-test, libblis-serial-dev,
Features: test-name=blis_blas_test_serial

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-openmp-dev,

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-pthread-dev,

Test-Command: sed -i -e 's@blis.h@blis64.h@' test/test_gemm.c;
 gcc test/test_gemm.c -DBLAS=\"blis\" -lblis64 -lm -o tester; ./tester
Restrictions: allow-stderr
Depends: build-essential, libblis64-dev, libblis64-serial-dev,

# ---------------- installation / maintainer script tests ---------------------

Test-Command: apt-get purge libblis-dev libblis-openmp-dev libblis-pthread-dev libblis-serial-dev -y
Restrictions: needs-root,
Depends: libblis-dev, libblis-openmp-dev, libblis-pthread-dev, libblis-serial-dev,
Features: test-name=blis_maintscript

Test-Command: apt-get purge libblis64-dev libblis64-openmp-dev libblis64-pthread-dev libblis64-serial-dev -y
Restrictions: needs-root,
Depends: libblis64-dev, libblis64-openmp-dev, libblis64-pthread-dev, libblis64-serial-dev,
Features: test-name=blis64_maintscript
